local myMod = ...

-- Apply building asset processor
myMod:registerAssetProcessor("models/stones.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/wooden_logs.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/torch.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/wooden_cb.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/wooden_fence.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/front_building_2am.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/tombstone.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register stones
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_STONES_PART",
	Name = "DECO_STONES_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_STONES"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register wood
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOOD_PART",
	Name = "DECO_WOOD_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOOD"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register wood plank
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOOD2_PART",
	Name = "DECO_WOOD2_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOOD2"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register torch
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TORCH_PART",
	Name = "DECO_TORCH_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_TORCH"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register lamp
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_LAMP_PART",
	Name = "DECO_LAMP_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_LAMP"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register barrel
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_BARREL1_PART",
	Name = "DECO_BARREL1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_BARREL1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register crate
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_CRATE1_PART",
	Name = "DECO_CRATE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_CRATE1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register fence
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FENCE1_PART",
	Name = "DECO_FENCE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FENCE1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register pillory
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_PILLORY1_PART",
	Name = "DECO_PILLORY1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_PILLORY1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register front building
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FRONTBUILDING1_PART",
	Name = "DECO_FRONTBUILDING1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FRONTBUILDING1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register tombstone
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TOMBSTONE1_PART",
	Name = "DECO_TOMBSTONE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_TOMBSTONE1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register tree oak
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREEOAK1_PART",
	Name = "DECO_TREEOAK1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_OAK"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree pine
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREEPINE1_PART",
	Name = "DECO_TREEPINE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_PINE"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree poplar
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREEPOPLAR1_PART",
	Name = "DECO_TREEPOPLAR1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_POPLAR"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree sycamore
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREESYCAMORE1_PART",
	Name = "DECO_TREESYCAMORE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_SYCAMORE"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})